// NextVer.c
// ES 24-03-2011	Nextver now with variable name and variable increment

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define HELPTEXT "NextVer [file = Version.h] ; [varname = BuildCount] ; [inc.= +1]\n\
NextVer reads filename & in-decrements the value after varname.\n"	

int main(int argc, char **argv)
{
int ret = 0;	// OK
int inc = 1;
char varname[256] = "BuildCount";
char filename[512] = "Version.h";
char sdest[512];
char buff[512];
char *pt,*pr;
int done,version;
FILE *f, *fd;
char b2[512];

	if(argc>1)
	{
		strcpy(filename, argv[1]);	// read filename
		if(strchr(filename, '?'))
		{
			printf(HELPTEXT);
			return 1;
		}
	}
	if(argc>2)
	  strcpy(varname, argv[2]);		// read varname
	if(argc>3)
	  sscanf(argv[3],"%d",&inc);	// read incrementer


	f = fopen(filename, "r");
	if(f==NULL)
	{
		printf(HELPTEXT);
		printf("\nError NextVer Can't open: %s for reading\n",filename);
		return 1;
	}

	strcpy(sdest,filename);
	pt = strrchr(sdest,'.');
	if(pt) pt[1]=0;				// remove extension
	strcat(sdest,"new");		// add .new
	fd = fopen(sdest, "w");
	if(fd==NULL)
	{
	  printf("Error NextVer Can't open: %s for writing\n",sdest);
	  fclose(f);
	  return 1;
	}

	done = 0;
	version = 0;

	while(fgets(buff,512, f))	// read a line from input
	{
		if(done==0)
		{
			if(strstr(buff, "#define")==buff)	// start with #define?
			{
				if( (pt=strstr(buff+7,varname)) ) // contains varname?
				{
					pt+=strlen(varname);
					while(*pt == ' ' || *pt<0x0A) pt++;	// skip ' ' and tab

					if(sscanf(pt,"%d", &version))
					{
						version+=inc;
						pr = pt;
						while((*pr>='0' && *pr<='9') || *pr=='-') 
							*(pr++)=' ';	// clear number

						strncpy(b2,buff, pt-buff);		// copy prefix
						sprintf(b2+(pt-buff),"%d",version);	// print new number
						strcat(b2,pr);			// add prefix
						strcpy(buff,b2);		// copy to buff
						done = 1;
					}
				}
			}
		}
		if(fputs(buff, fd)<0)
		{
			printf("Error NextVer Error writing: %s\n",sdest);
			ret = 1;
			done = 0;
			break;
		}
	}
	fclose(fd);
	fclose(f);
	if(done)
	{
		printf("Next Version: %s = %d\n",varname,version);
		strcpy(buff,filename);
		pt = strrchr(buff,'.');
		if(pt) pt[1]=0;			// remove extension
		strcat(buff,"bak");		// add .bak
		remove(buff);			// delete .bak
		rename(filename,buff);	// .h -> .bak
		remove(filename);		// delete .h
		rename(sdest,filename);	// .new -> .h
	} else {
		if(ret==0)
		{
			printf("Error NextVer name:%s or number not found\n",varname);
			ret = 2;	// return not error but fail
		}
	}
	return ret;	// 0=ok >0 = error
}

